<?php
function json_format($json) {
  if (!is_string($json)) {
    if (phpversion() && phpversion() >= 5.4) {
      return json_encode($json, JSON_PRETTY_PRINT);
    }
    $json = json_encode($json);
  }
   $json =  u_decode($json);
   
  $result      = '';
  $pos         = 0;               // indentation level
  $strLen      = strlen($json);
  $indentStr   = "\t";
  $newLine     = "\n";
  $prevChar    = '';
  $outOfQuotes = true;

  for ($i = 0; $i < $strLen; $i++) {
    $copyLen = strcspn($json, $outOfQuotes ? " \t\r\n\",:[{}]" : "\\\"", $i);
	if ($copyLen >= 1) {
      $copyStr = substr($json, $i, $copyLen);
      $prevChar = '';
      $result .= $copyStr;
      $i += $copyLen - 1;      // correct for the for(;;) loop
     
	  continue;
    }
    
    $char = substr($json, $i, 1);
    
    if (!$outOfQuotes && $prevChar === '\\') {
      $result .= $char;
      $prevChar = '';
      continue;
    }
    if ($char === '"' && $prevChar !== '\\') {
      $outOfQuotes = !$outOfQuotes;
    }
    else if ($outOfQuotes && ($char === '}' || $char === ']')) {
      $result .= $newLine;
      $pos--;
      for ($j = 0; $j < $pos; $j++) {
        $result .= $indentStr;
      }
    }
    else if ($outOfQuotes && false !== strpos(" \t\r\n", $char)) {
      continue;
    }

    $result .= $char;
    if ($outOfQuotes && $char === ':') {
      $result .= ' ';
    }

    else if ($outOfQuotes && ($char === ',' || $char === '{' || $char === '[')) {
      $result .= $newLine;
      if ($char === '{' || $char === '[') {
        $pos++;
      }
      for ($j = 0; $j < $pos; $j++) {
        $result .= $indentStr;
      }
    }
    $prevChar = $char;
  }

  return $result;
}
function mat($matches) {
	return mb_convert_encoding(pack('H*',$matches[1]),'UTF-8','UTF-16');
}

function u_decode($input){
	return preg_replace_callback( '/\\\\u([0-9a-zA-Z]{4})/', mat , $input );
}

function raw_json_encode($input) {
// convert 2 utf8 json encode 
	return u_decode( json_encode($input) );
}
?>